/*************************************************************************
*                                                                        *
*   Module: SearchEvidenceExons                                          *
*                                                                        *
*   Searching evidence exons between (l1, l2).                           *
*                                                                        *
*   This file is part of the geneidP Distribution                        *
*                                                                        *
*     Copyright (C) 2000 - Enrique BLANCO GARCIA                         *
*                          Roderic GUIGO SERRA                           *
*                                                                        *
*  This program is free software; you can redistribute it and/or modify  *
*  it under the terms of the GNU General Public License as published by  *
*  the Free Software Foundation; either version 2 of the License, or     *
*  (at your option) any later version.                                   *
*                                                                        *
*  This program is distributed in the hope that it will be useful,       *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*  GNU General Public License for more details.                          *
*                                                                        *
*  You should have received a copy of the GNU General Public License     *
*  along with this program; if not, write to the Free Software           *
*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             *
*************************************************************************/  

/* $Id: SearchEvidenceExons.c,v 1.1 2001/01/08 08:17:08 eblanco Exp $ */

#include "geneid.h"

long SearchEvidenceExons(packEvidence* pv, long l2, params* p)
{
  long i;
  
  i = p->i1vExons;
  while ((i < pv->nvExons) && ((pv->vExons+i)->Acceptor->Position) < l2)
    i++;
    
  p->i2vExons = i;

  return(p->i2vExons - p->i1vExons);
}

void SwitchCounters(params* p)
{
  p->i1vExons = p->i2vExons;
}

void InitEvidenceCounter(packEvidence* pv, long l1, params* p)
{
  long i;

  i = p->i1vExons;

  while ((i < pv->nvExons) && ((pv->vExons+i)->Acceptor->Position) < l1)
    i++;

  p->i1vExons = i;
}
